Package weka.estimators

# Class UnivariateEqualFrequencyHistogramEstimator

java.lang.Object
weka.estimators.UnivariateEqualFrequencyHistogramEstimator

All Implemented Interfaces:
  `Serializable`, `RevisionHandler`, `UnivariateDensityEstimator`, `UnivariateIntervalEstimator`, `UnivariateQuantileEstimator`

public class UnivariateEqualFrequencyHistogramEstimator extends Object implements UnivariateDensityEstimator, UnivariateIntervalEstimator, UnivariateQuantileEstimator, Serializable
Simple histogram density estimator. Uses equal-frequency histograms based on the specified number of bins (default: 10).

Version:
  $Revision: 11318 $
Author:
  Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final double`
  `CONST`
  Constant for Gaussian density.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `UnivariateEqualFrequencyHistogramEstimator()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addValue(double value, double weight)`
  Adds a value to the density estimator.
  `int`
  `getNumBins()`
  Gets the number of bins
  `String`
  `getRevision()`
  Returns the revision string.
  `boolean`
  `getUpdateWeightsOnly()`
  Gets whether only weights should be udpated.*
  `String`
  `globalInfo()`
  Returns a string describing the estimator.
  `void`
  `initializeStatistics()`
  Triggers construction of estimator based on current data and then initializes the statistics.
  `double`
  `logDensity(double value)`
  Returns the natural logarithm of the density estimate at the given point.
  `static void`
  `main(String[] args)`
  Main method, used for testing this class.
  `double[][]`
  `predictIntervals(double conf)`
  Returns the interval for the given confidence value.
  `double`
  `predictQuantile(double percentage)`
  Returns the quantile for the given percentage.
  `void`
  `setNumBins(int numBins)`
  Sets the number of bins
  `void`
  `setUpdateWeightsOnly(boolean flag)`
  Sets whether only weights should be udpated.
  `String`
  `toString()`
  Returns textual description of this estimator.

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### CONST

    public static final double CONST
    Constant for Gaussian density.

- ## Constructor Details

  - ### UnivariateEqualFrequencyHistogramEstimator

    public UnivariateEqualFrequencyHistogramEstimator()

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Returns a string describing the estimator.

  - ### getNumBins

    public int getNumBins()
    Gets the number of bins
    Returns:
      the number of bins.

  - ### setNumBins

    public void setNumBins(int numBins)
    Sets the number of bins
    Parameters:
      `numBins` - the number of bins

  - ### initializeStatistics

    public void initializeStatistics()
    Triggers construction of estimator based on current data and then initializes the statistics.

  - ### setUpdateWeightsOnly

    public void setUpdateWeightsOnly(boolean flag)
    Sets whether only weights should be udpated.

  - ### getUpdateWeightsOnly

    public boolean getUpdateWeightsOnly()
    Gets whether only weights should be udpated.*

  - ### addValue

    public void addValue(double value, double weight)
    Adds a value to the density estimator.
    Specified by:
      `addValue` in interface `UnivariateDensityEstimator`
    Specified by:
      `addValue` in interface `UnivariateIntervalEstimator`
    Specified by:
      `addValue` in interface `UnivariateQuantileEstimator`
    Parameters:
      `value` - the value to add
      `weight` - the weight of the value

  - ### predictIntervals

    public double[][] predictIntervals(double conf)
    Returns the interval for the given confidence value.
    Specified by:
      `predictIntervals` in interface `UnivariateIntervalEstimator`
    Parameters:
      `conf` - the confidence value in the interval [0, 1]
    Returns:
      the interval

  - ### predictQuantile

    public double predictQuantile(double percentage)
    Returns the quantile for the given percentage.
    Specified by:
      `predictQuantile` in interface `UnivariateQuantileEstimator`
    Parameters:
      `percentage` - the percentage
    Returns:
      the quantile

  - ### logDensity

    public double logDensity(double value)
    Returns the natural logarithm of the density estimate at the given point.
    Specified by:
      `logDensity` in interface `UnivariateDensityEstimator`
    Parameters:
      `value` - the value at which to evaluate
    Returns:
      the natural logarithm of the density estimate at the given value

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Returns:
      the revision

  - ### toString

    public String toString()
    Returns textual description of this estimator.
    Overrides:
      `toString` in class `Object`

  - ### main

    public static void main(String[] args)
    Main method, used for testing this class.